package com.effectiveui.msdn;

import java.io.BufferedReader;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.UnsupportedEncodingException;
import java.nio.charset.Charset;
import java.util.UUID;

import org.apache.http.HttpResponse;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.mime.HttpMultipartMode;
import org.apache.http.entity.mime.MultipartEntity;
import org.apache.http.entity.mime.content.ByteArrayBody;
import org.apache.http.entity.mime.content.StringBody;
import org.apache.http.impl.client.DefaultHttpClient;

import com.effectiveui.msdn.EffectiveUIActivity;
import com.effectiveui.msdn.R;

import android.app.Activity;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.Bitmap.CompressFormat;
import android.os.Bundle;
import android.webkit.WebChromeClient;
import android.webkit.WebView;
import android.webkit.WebViewClient;
import android.webkit.GeolocationPermissions;

public class EffectiveUIActivity extends Activity {
    /** Called when the activity is first created. */
	WebView webView;
	String cameraId;

	static String baseURL = "http://192.168.14.68:15323/";

	@Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);

        webView = (WebView)findViewById(R.id.webView);
        webView.getSettings().setJavaScriptEnabled(true);
        webView.getSettings().setGeolocationEnabled(true);
        webView.setVerticalScrollbarOverlay(true);
        webView.loadUrl(baseURL);
        
        final EffectiveUIActivity activity = this;
        webView.setWebViewClient(new WebViewClient(){
        	@Override
        	public void onLoadResource(WebView view, String url) {
        		super.onLoadResource(view, url);
        		
        		if(url.contains("Home/Image")){
        			activity.createCamera();
        		}
        	}
        	@Override
        	public boolean shouldOverrideUrlLoading(WebView view, String url){
        		String match = "Home/Image/";
        		int i = url.indexOf(match);
        		if(i>0){
        			cameraId = url.substring(i+match.length());
        			activity.createCamera();
        			return true;
        		}
        		return false;
        	}
        });
        webView.setWebChromeClient(new WebChromeClient(){
        	@Override
        	public void onGeolocationPermissionsShowPrompt(String origin, GeolocationPermissions.Callback callback) {
        		super.onGeolocationPermissionsShowPrompt(origin, callback);
        		callback.invoke(origin, true, false);
        	}

        });        
	}
	
    public void createCamera(){
    	Intent intent = new Intent("android.media.action.IMAGE_CAPTURE");
    	startActivityForResult(intent, 2000);
    }
    
    @Override
	public void onActivityResult(int requestCode, int resultCode, Intent data) {
	  if (resultCode == Activity.RESULT_OK && requestCode == 2000) {
		  Bitmap thumbnail = (Bitmap) data.getExtras().get("data");
		  ByteArrayOutputStream bos = new ByteArrayOutputStream();
		  thumbnail.compress(CompressFormat.JPEG, 75, bos);
		  byte[] imagebytes = bos.toByteArray();
		  
		  ByteArrayBody bab = new ByteArrayBody(imagebytes, "image/jpeg", UUID.nameUUIDFromBytes(imagebytes).toString()+".jpg");
		  HttpClient client = new DefaultHttpClient();
		  HttpPost post = new HttpPost(baseURL+"Home/UploadPicture");
		  MultipartEntity reqEntity = new MultipartEntity(HttpMultipartMode.BROWSER_COMPATIBLE);
		  reqEntity.addPart("photo", bab);
		  try {
			reqEntity.addPart("ID", new StringBody(cameraId, "text/plain", Charset.forName( "UTF-8" )));
		} catch (UnsupportedEncodingException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		  post.setEntity(reqEntity);
		  try {
			HttpResponse response = client.execute(post);
			BufferedReader reader = new BufferedReader(new InputStreamReader( response.getEntity().getContent(), "UTF-8"));
			String sResponse;
			StringBuilder s = new StringBuilder();
			
			while ((sResponse = reader.readLine()) != null) {
					s = s.append(sResponse);
			}
		} catch (ClientProtocolException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		  webView.loadUrl(webView.getUrl());
	  }
	}	
}