﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Tasks;
using System.Windows.Media.Imaging;
using BrianGrinstead;

namespace EffectiveUI.MSDN.Phone
{
	public partial class MainPage : PhoneApplicationPage
	{
		CameraCaptureTask cameraCaptureTask;
		BitmapImage bmp;
		string id = "";
		string baseURL = "http://shane-church-pc.effectiveui.loc:15323/"; //TODO: Update this URL to your local machine name and port where the web application is running

		// Constructor
		public MainPage()
		{
			InitializeComponent();
			cameraCaptureTask = new CameraCaptureTask();
			cameraCaptureTask.Completed += new EventHandler<PhotoResult>(photoCaptureOrSelectionCompleted);
		}

		private void webBrowser1_Navigating(object sender, NavigatingEventArgs e)
		{
			//Catch Navigation and launch local camera
			if (e.Uri.AbsoluteUri.ToLower().Contains("home/image"))
			{
				id = e.Uri.AbsoluteUri.Substring(e.Uri.AbsoluteUri.LastIndexOf("/") + 1);
				cameraCaptureTask.Show();
				e.Cancel = true;
			}
		}

		void photoCaptureOrSelectionCompleted(object sender, PhotoResult e)
		{
			if (e.TaskResult == TaskResult.OK)
			{
				byte[] data = new byte[e.ChosenPhoto.Length];
				e.ChosenPhoto.Read(data, 0, data.Length);
				e.ChosenPhoto.Close();

				Guid fileId = Guid.NewGuid();
				Dictionary<string, object> postParameters = new Dictionary<string, object>();
				postParameters.Add("photo", new FormUpload.FileParameter(data, fileId.ToString() + ".jpg", "image/jpeg"));

				FormUpload upload = new FormUpload(baseURL + "Home/UploadPicture/" + id, postParameters);
				upload.FormUploadCompleted += new FormUpload.FormUploadCompletedHandler(upload_FormUploadCompleted);
				upload.BeginMultipartFormDataPost();
			}
		}

		void upload_FormUploadCompleted(object source)
		{
			webBrowser1.Navigate(webBrowser1.Source);
		}

		private void PhoneApplicationPage_Loaded(object sender, RoutedEventArgs e)
		{
			webBrowser1.Navigate(new Uri(baseURL));
		}
	}
}