﻿using System;
using System.IO;

namespace EffectiveUI.MSDN.Web.Utility
{
	public class Utility
	{
		/// <summary>
		/// Finds the path of the assembly. This is used to determine the path to Load/Save the XML files in.
		/// </summary>
		/// <returns>A fully-qualified path to be used when creating a FileStream to use when serializing/deserializing</returns>
		public static string GetAssemblyPath()
		{
			// Find the URI path of the executing assembly
			var assemblyPath = System.Reflection.Assembly.GetExecutingAssembly().CodeBase;

			// Convert the URI to a local path
			var uri = new Uri(assemblyPath);
			assemblyPath = uri.LocalPath;
			return Path.GetDirectoryName(assemblyPath);
		}
	}
}